#include <amxmodx>
#include <cstrike>

#define CMDTARGET_OBEY_IMMUNITY (1<<0)
#define CMDTARGET_ALLOW_SELF	(1<<1)
#define CMDTARGET_ONLY_ALIVE	(1<<2)
#define CMDTARGET_NO_BOTS	(1<<3)

new const bars[] = "/";

new command[][] =
{
   "/t", 
   "/ct",
   "/spec" 
};

new Caccess[] =
{
   ADMIN_ALL,
   ADMIN_ALL,
   ADMIN_ALL
};

public plugin_init()
{
   register_plugin("Admin Transfer", "1.0", "x");
   register_cvar("Admin_Transfer", "1.0.x", FCVAR_SERVER | FCVAR_SPONLY);

   register_concmd("amx_t", "LInkCS1", ADMIN_KICK, "<nume>  - muti pe cineva la terro");
   register_concmd("admin_t", "LInkCS1", ADMIN_KICK, "<nume> - muti pe cineva la terro");

   register_concmd("amx_ct", "LInkCS2", ADMIN_KICK, "<nume> - muti pe cineva la ct");
   register_concmd("admin_ct", "LInkCS2", ADMIN_KICK, "<nume> - muti pe cineva la ct");

   register_concmd("amx_spec", "LInkCS3", ADMIN_KICK, "<nume> - muti pe cineva spectator");
   register_concmd("admin_spec", "LInkCS3", ADMIN_KICK, "<nume> - muti pe cineva spectator");

   register_clcmd ("say", "hook_say");

   return PLUGIN_CONTINUE;
}

public hook_say(index)
{
   static arg[192], command2[192];
   read_args(arg, charsmax (arg));
	
   if (!arg[0])
      return PLUGIN_CONTINUE;

   remove_quotes(arg[0]);
	
   for (new x; x < sizeof command; x++)
   {
    if(equal(arg, command[x], strlen(command[x])))
    {
     if(get_user_flags(index) & Caccess[x])
     {
       replace(arg, charsmax(arg), bars, "");
       formatex(command2, charsmax(command2), "amx_%s", arg);
       client_cmd(index, command2);
     }		
     break;
    }
   }	
   return PLUGIN_CONTINUE;
}

public LInkCS1(id, level, cid)
{ 
   if (!cmd_access(id, level, cid, 2))
	return PLUGIN_HANDLED;

   new unu[32]

   read_argv(1, unu, 31);

   new player = cmd_target(id, unu, CMDTARGET_OBEY_IMMUNITY | CMDTARGET_NO_BOTS | CMDTARGET_ALLOW_SELF);

   if (!player) 
	return PLUGIN_HANDLED;

   static name[32], Admin[32];

   get_user_name(player, name, 31);
   get_user_name(id, Admin, 31);	

   new NumeEchipa[32];
   NumeEchipa = cs_get_user_team(player) == CS_TEAM_T

   cs_set_user_team(player, CS_TEAM_T);
   NumeEchipa = "Terrorists";
   user_silentkill(player);

   client_print(0, print_chat, "ADMIN %s: transfer %s la echipa TERRO", Admin, name); 

   return PLUGIN_HANDLED;
}

public LInkCS2(id, level, cid)
{ 
   if (!cmd_access(id, level, cid, 2))
	return PLUGIN_HANDLED;

   new unu[32]

   read_argv(1, unu, 31);

   new player = cmd_target(id, unu, CMDTARGET_OBEY_IMMUNITY | CMDTARGET_NO_BOTS | CMDTARGET_ALLOW_SELF);

   if (!player) 
	return PLUGIN_HANDLED;

   static name[32], Admin[32];

   get_user_name(player, name, 31);
   get_user_name(id, Admin, 31);	

   new NumeEchipa[32];

   NumeEchipa = cs_get_user_team(player) == CS_TEAM_CT

   cs_set_user_team(player, CS_TEAM_CT);
   NumeEchipa = "Counter-Terrorists";
   user_silentkill(player);

   client_print(0, print_chat, "ADMIN %s: transfer %s la echipa CT", Admin, name); 

   return PLUGIN_HANDLED;
}

public LInkCS3(id, level, cid)
{ 
   if (!cmd_access(id, level, cid, 2))
	return PLUGIN_HANDLED;

   new unu[32]

   read_argv(1, unu, 31);

   new player = cmd_target(id, unu, CMDTARGET_OBEY_IMMUNITY | CMDTARGET_NO_BOTS | CMDTARGET_ALLOW_SELF);

   if (!player) 
	return PLUGIN_HANDLED;

   static name[32], Admin[32];

   get_user_name(player, name, 31);
   get_user_name(id, Admin, 31);	

   new NumeEchipa[32];
   NumeEchipa = cs_get_user_team(player) == CS_TEAM_SPECTATOR

   cs_set_user_team(player, CS_TEAM_SPECTATOR);
   NumeEchipa = "Spectator";
   user_silentkill(player);

   client_print(0, print_chat, "ADMIN %s: transfer %s SPECTATOR", Admin, name); 

   return PLUGIN_HANDLED;
}

stock is_user_admin(id)
{
   return (get_user_flags(id) > 0 && !(get_user_flags(id) & ADMIN_USER));
}

stock cmd_access(id, level, cid, num) 
{
   new has_access = 0;

   if(id == (is_dedicated_server() ? 0 : 1)) 
   {
      has_access = 1;
   }
   else if(level == ADMIN_ADMIN)
   {
      if (is_user_admin(id))
      {
	has_access = 1;
      }
   }
   else if(get_user_flags(id) & level)
   {
      has_access = 1;
   }
   else if(level == ADMIN_ALL) 
   {
      has_access = 1;
   }

   if(has_access == 0) 
   {
      client_print(id, print_chat, "Nu ai acces la aceasta comanda!");
      console_print(id, "Nu ai acces la aceasta comanda!");
      return 0;
   }
   if(read_argc() < num) 
   {
      new hcmd[32], hinfo[128], hflag;
      get_concmd(cid, hcmd, 31, hflag, hinfo, 127, level);

      client_print(id, print_chat, "Foloseste comanda: /transfer <nume> <echipa>");
      console_print(id, "Foloseste comanda: %s %s", hcmd, hinfo);
      return 0;
   }
   return PLUGIN_HANDLED;
}

stock access(id, level) 
{
   if(level == ADMIN_ADMIN)
   {
      return is_user_admin(id);
   }
   return (get_user_flags(id) & level);
}

stock cmd_target(id, const arg[], flags = CMDTARGET_OBEY_IMMUNITY) 
{
   new player = find_player("bl", arg);

   if(player) 
   {
      if(player != find_player("blj", arg)) 
      {  
        client_print(id, print_chat, "Sunt mai multi jucatori care se potrivesc la nume cu ce ai scris tu!");
        console_print(id, "Sunt mai multi jucatori care se potrivesc la nume cu ce ai scris tu!");
        return 0;
      }
   }
   else if((player = find_player("c", arg)) == 0 && arg[0] == '#' && arg[1])
   {
      player = find_player("k", str_to_num(arg[1]));
   }
   if(!player) 
   {
      client_print(id, print_chat, "Jucatorul nu a fost gasit!");
      client_print(id, print_chat, "Verifica daca ai scris bine sau daca jucatorul mai este pe server, si incearca iar!");
      console_print(id, "Jucatorul nu a fost gasit!");
      console_print(id, "Verifica daca ai scris bine sau daca jucatorul mai este pe server, si incearca iar!");
      return 0;
   }
   if (flags & CMDTARGET_OBEY_IMMUNITY) 
   {
      if((get_user_flags(player) & ADMIN_IMMUNITY) && ((flags & CMDTARGET_ALLOW_SELF) ? (id != player) : true))  
      {
	new imname[32];
	get_user_name(player, imname, 31);

	client_print(id, print_chat, "Jucatorul %s are imunitate!", imname);
	client_print(id, print_chat, "Poate este ADMIN, cauta comanda de setare imunitate si seteaz-o OFF , daca ai acces!");
	console_print(id, "Jucatorul %s are imunitate!", imname);
	console_print(id, "Poate este ADMIN, cauta comanda de setare imunitate si seteaz-o OFF , daca ai acces!");
	return 0;
      }
   }
   if (flags & 4) 
   {
      if(!is_user_alive(player)) 
      {
	new imname[32];
	get_user_name(player, imname, 31);

	client_print(id, print_chat, "Jucatorul %s este mort!", imname);
	client_print(id, print_chat, "Asteapta sa inceapa urmatoarea runda!");
	console_print(id, "Jucatorul %s este mort!", imname);
	console_print(id, "Asteapta sa inceapa urmatoarea runda!");
        return 0;
      }
   }
   if (flags & 8) 
   {
      if(is_user_bot(player)) 
      {
	new imname[32];
	get_user_name(player, imname, 31);

	client_print(id, print_chat, "Jucatorul %s nu este real, este bot , ce inseamna ca nu poti executa nici o comanda pe el!", imname);
	console_print(id, "Jucatorul %s nu este real, este bot , ce inseamna ca nu poti executa nici o comanda pe el!", imname);
	return 0;
      }
   }
   return player;
}